# Function UseOptionsDataSource

- UseOptionsDataSource<Source>(
  dataSource: IdOrInstanceOrToken<
  BaseDataSource<
  Source,
  BaseDataSourceMetadata,
  BaseDataSourceViewer<any>,
  >,
  >,
  settings?: InputSelectOptionsSettings<Source>,
  ): (target: any, propertyKey: string) => any

  #### Type Parameters

  - Source

  #### Parameters

  - dataSource: IdOrInstanceOrToken<
    BaseDataSource<
    Source,
    BaseDataSourceMetadata,
    BaseDataSourceViewer<any>,
    >,
    >
  - `Optional` settings: InputSelectOptionsSettings<Source>

  #### Returns (target: any, propertyKey: string) => any

  - Defined in packages/angular/form-system/src/lib/mixins/extract-options-data-source.mixin.ts:39